diff -u -Naur eperl-2.2.14/eperl_perl5.c eperl-2.2.14.fink/eperl_perl5.c
--- eperl-2.2.14/eperl_perl5.c	Sun Aug  2 10:33:55 1998
+++ eperl-2.2.14.fink/eperl_perl5.c	Wed Nov 17 12:45:58 2004
@@ -15,7 +15,7 @@
 **
 **  ======================================================================
 **
-**  Copyright (c) 1996,1997,1998 Ralf S. Engelschall <rse@engelschall.com>
+**  Copyright (c) 1996,1997,1998,1999 Ralf S. Engelschall <rse@engelschall.com>
 **
 **  This program is free software; it may be redistributed and/or modified
 **  only under the terms of either the Artistic License or the GNU General
@@ -41,14 +41,28 @@
 
 #ifdef HAVE_PERL_DYNALOADER
 
-extern void boot_DynaLoader _((CV* cv));
+extern void boot_DynaLoader _((pTHX_ CV* cv));
+
+void give_version_extended_perl(void)
+{
+    give_version();
+    fprintf(stdout, "Characteristics of this binary:\n");
+    fprintf(stdout, "  Perl Version    : %s (%s)\n", AC_perl_vers, AC_perl_prog);
+    fprintf(stdout, "  Perl I/O Layer  : %s\n", PERL_IO_LAYER_ID);
+    fprintf(stdout, "  Perl Library    : %s/CORE/libperl.a\n", AC_perl_archlib);
+    fprintf(stdout, "  Perl DynaLoader : %s\n", AC_perl_dla);
+    fprintf(stdout, "  System Libs     : %s\n", AC_perl_libs);
+    fprintf(stdout, "  Built User      : %s\n", AC_build_user);
+    fprintf(stdout, "  Built Time      : %s\n", AC_build_time_iso);
+    fprintf(stdout, "\n");
+}
 
 /*
 **
 **  the Perl XS init function for dynamic library loading
 **
 */
-void Perl5_XSInit(void)
+void Perl5_XSInit(pTHX)
 {
    char *file = __FILE__;
    /* dXSUB_SYS; */
@@ -64,13 +78,10 @@
 **  Force Perl to use unbuffered I/O
 **
 */
-void Perl5_ForceUnbufferedStdout(void)
+void Perl5_ForceUnbufferedStdout(pTHX)
 {
-#if AC_perl_vnum < 500476
-    IoFLAGS(GvIOp(defoutgv)) |= IOf_FLUSH; /* $|=1 */
-#else
+    dTHR;
     IoFLAGS(GvIOp(PL_defoutgv)) |= IOf_FLUSH; /* $|=1 */
-#endif
     return;
 }
 
@@ -84,9 +95,13 @@
     char ca[1024];
     char *cp;
 
-    strcpy(ca, str);
+    strncpy(ca, str, 1023);
+    ca[1023] = NUL;
     cp = strchr(ca, '=');
-    *cp++ = '\0';
+    if (cp != NULL)
+        *cp++ = '\0';
+    else
+        cp = "";
     return mysetenv(env, ca, cp);
 }
 
@@ -95,11 +110,12 @@
 **  sets a Perl scalar variable
 **
 */
-void Perl5_SetScalar(char *pname, char *vname, char *vvalue)
+void Perl5_SetScalar(pTHX_ char *pname, char *vname, char *vvalue)
 {
+    dTHR;
     ENTER;
-    save_hptr(&curstash); 
-    curstash = gv_stashpv(pname, TRUE);
+    save_hptr(&PL_curstash); 
+    PL_curstash = gv_stashpv(pname, TRUE);
     sv_setpv(perl_get_sv(vname, TRUE), vvalue);
     LEAVE;
     return;
@@ -131,18 +147,146 @@
     return;
 }
 
-void Perl5_SetRememberedScalars(void) 
+void Perl5_SetRememberedScalars(pTHX) 
 {
     char ca[1024];
     char *cp;
     int i;
 
     for (i = 0; Perl5_RememberedScalars[i] != NULL; i++) {
-        strcpy(ca, Perl5_RememberedScalars[i]);
+        strncpy(ca, Perl5_RememberedScalars[i], 1023);
+        ca[1023] = NUL;
         cp = strchr(ca, '=');
-        *cp++ = '\0';
-        Perl5_SetScalar("main", ca, cp);
+        if (cp != NULL)
+            *cp++ = '\0';
+        else
+            cp = "";
+        Perl5_SetScalar(aTHX_ "main", ca, cp);
+    }
+}
+
+int Perl5_Run(int myargc, char **myargv, int mode, int fCheck, int keepcwd, char *source, char **env, char *perlscript, char *perlstderr, char *perlstdout)
+{
+    DECL_EXRC;
+    FILE *er;
+    FILE *out;
+    char *cpBuf = NULL;
+    char sourcedir[2048];
+    char *cp;
+    static PerlInterpreter *my_perl = NULL; 
+    struct stat st;
+    int size;
+    char cwd[MAXPATHLEN];
+
+    /* open a file for Perl's STDOUT channel
+       and redirect stdout to the new channel */
+    if ((out = fopen(perlstdout, "w")) == NULL) {
+        PrintError(mode, source, NULL, NULL, "Cannot open STDOUT file `%s' for writing", perlstdout);
+        CU(mode == MODE_FILTER ? EX_IOERR : EX_OK);
+    }
+    IO_redirect_stdout(out);
+
+    /* open a file for Perl's STDERR channel 
+       and redirect stderr to the new channel */
+    if ((er = fopen(perlstderr, "w")) == NULL) {
+        PrintError(mode, source, NULL, NULL, "Cannot open STDERR file `%s' for writing", perlstderr);
+        CU(mode == MODE_FILTER ? EX_IOERR : EX_OK);
+    }
+    IO_redirect_stderr(er);
+
+    my_perl = perl_alloc();   
+    perl_construct(my_perl); 
+    perl_init_i18nl10n(1);
+
+    /*  now parse the script! 
+        NOTICE: At this point, the script gets 
+        only _parsed_, not evaluated/executed!  */
+#ifdef HAVE_PERL_DYNALOADER
+    rc = perl_parse(my_perl, Perl5_XSInit, myargc, myargv, env);
+#else
+    rc = perl_parse(my_perl, NULL, myargc, myargv, env);
+#endif
+    if (rc != 0) { 
+        if (fCheck && mode == MODE_FILTER) {
+            fclose(er); er = NULL;
+            IO_restore_stdout();
+            IO_restore_stderr();
+            if ((cpBuf = ePerl_ReadErrorFile(perlstderr, perlscript, source)) != NULL) {
+                fprintf(stderr, cpBuf);
+            }
+            CU(EX_FAIL);
+        }
+        else {
+            fclose(er); er = NULL;
+            PrintError(mode, source, perlscript, perlstderr, "Perl parsing error (interpreter rc=%d)", rc);
+            CU(mode == MODE_FILTER ? EX_FAIL : EX_OK);
+        }
+    }
+
+    /* Stop when we are just doing a syntax check */
+    if (fCheck && mode == MODE_FILTER) {
+        fclose(er); er = NULL;
+        IO_restore_stdout();
+        IO_restore_stderr();
+        fprintf(stderr, "%s syntax OK\n", source);
+        CU(-1);
+    }
+
+    /* change to directory of script:
+       this actually is not important to us, but really useful 
+       for the ePerl source file programmer!! */
+    cwd[0] = NUL;
+    if (!keepcwd) {
+        /* if running as a Unix filter remember the cwd for outputfile */
+        if (mode == MODE_FILTER)
+            getcwd(cwd, MAXPATHLEN);
+        /* determine dir of source file and switch to it */
+        strncpy(sourcedir, source, sizeof(sourcedir));
+        sourcedir[sizeof(sourcedir)-1] = NUL;
+        for (cp = sourcedir+strlen(sourcedir); cp > sourcedir && *cp != '/'; cp--)
+            ;
+        *cp = NUL;
+        chdir(sourcedir);
+    }
+
+    /*  Set the previously remembered Perl 5 scalars (option -d) */
+    Perl5_SetRememberedScalars(aTHX);
+
+    /*  Force unbuffered I/O */
+    Perl5_ForceUnbufferedStdout(aTHX);
+
+    /*  NOW IT IS TIME to evaluate/execute the script!!! */
+    rc = perl_run(my_perl);
+
+    /*  pre-close the handles, to be able to check
+        its size and to be able to display the contents */
+    fclose(out); out = NULL;
+    fclose(er);  er  = NULL;
+
+    /* ok, now recover the stdout and stderr */
+    IO_restore_stdout();
+    IO_restore_stderr();
+
+    /*  when the Perl interpreter failed or there
+        is data on stderr, we print a error page */
+    if (stat(perlstderr, &st) == 0)
+        size = st.st_size;
+    else
+        size = 0;
+    if (rc != 0 || size > 0) {
+        PrintError(mode, source, perlscript, perlstderr, "Perl runtime error (interpreter rc=%d)", rc);
+        CU(mode == MODE_FILTER ? EX_FAIL : EX_OK);
+    }
+
+    CUS: /* the Clean Up Sequence */
+
+    /* Ok, the script got evaluated. Now we can destroy 
+       and de-allocate the Perl interpreter */
+    if (my_perl) {
+       perl_destruct(my_perl);                                                    
+       perl_free(my_perl);
     }
+    return rc;
 }
 
 /*EOF*/
diff -u -Naur eperl-2.2.14/eperl_perl5.h eperl-2.2.14.fink/eperl_perl5.h
--- eperl-2.2.14/eperl_perl5.h	Fri Jul 10 03:52:13 1998
+++ eperl-2.2.14.fink/eperl_perl5.h	Wed Nov 17 12:45:58 2004
@@ -15,7 +15,7 @@
 **
 **  ======================================================================
 **
-**  Copyright (c) 1996,1997,1998 Ralf S. Engelschall <rse@engelschall.com>
+**  Copyright (c) 1996,1997,1998,1999 Ralf S. Engelschall <rse@engelschall.com>
 **
 **  This program is free software; it may be redistributed and/or modified
 **  only under the terms of either the Artistic License or the GNU General
@@ -38,28 +38,69 @@
 
 /*  first include the standard Perl 
     includes designed for embedding   */
+#define PERL_NO_GET_CONTEXT     /* for efficiency reasons, see perlguts(3) */
 #include <EXTERN.h>
 #include <perl.h>                 
 
-
-/*  try to adjust for PerlIO handling  */
-#ifdef USE_PERLIO
-#undef  fwrite
-#define fwrite(buf,size,count,f) PerlIO_write(f,buf,size*count)
+#ifndef dTHR
+#  ifdef WIN32
+#       define dTHR extern int Perl___notused
+#  else
+#       define dTHR extern int errno
+#  endif
 #endif
 
+#ifndef aTHX
+#  define aTHX
+#  define aTHX_
+#  define pTHX void
+#  define pTHX_
+#endif
 
 /*  define the I/O type string for verbosity */
 #ifdef USE_PERLIO
-#ifdef USE_SFIO
-#define PERL_IO_LAYER_ID "PerlIO/SfIO"
+#  ifdef USE_SFIO
+#    define PERL_IO_LAYER_ID "PerlIO/SfIO"
+#  else
+#    define PERL_IO_LAYER_ID "PerlIO/StdIO"
+#  endif
 #else
-#define PERL_IO_LAYER_ID "PerlIO/StdIO"
+#  define PERL_IO_LAYER_ID "Raw/StdIO"
+#endif
+
+#if (PERL_VERSION < 4) || ((PERL_VERSION == 4) && (PERL_SUBVERSION <= 5))
+#  define PL_curstash curstash
 #endif
+
+#ifndef WITH_THR
+#  define PL_defoutgv defoutgv
+#endif
+
+/*  
+  Initialization of locales when building a new Perl interpreter.
+     Perl 5.003 calls perl_init_i18nl14n
+     Perl 5.004 and 5.005 call perl_init_i18nl10n
+     In Perl 5.6.0 this routine is already called by perl_construct
+*/
+#ifndef perl_init_i18nl10n
+#  define perl_init_i18nl10n perl_init_i18nl14n
 #else
-#define PERL_IO_LAYER_ID "Raw/StdIO"
+#  if (PERL_REVISION > 5) || ((PERL_REVISION == 5) && (PERL_VERSION >= 6))
+#    undef perl_init_i18nl10n
+#    define perl_init_i18nl10n(a)
+#  endif
 #endif
 
+/* eperl_perl5.c */
+/*  These prototypes can no longer be included in eperl_proto.h because
+    pTHX argument has been introduced in Perl 5.6.0  */
+extern void Perl5_XSInit(pTHX);
+extern void Perl5_ForceUnbufferedStdout(pTHX);
+extern char **Perl5_SetEnvVar(char **env, char *str);
+extern void Perl5_SetScalar(pTHX_ char *pname, char *vname, char *vvalue);
+extern char *Perl5_RememberedScalars[1024];
+extern void Perl5_RememberScalar(char *str);
+extern void Perl5_SetRememberedScalars(pTHX);
 
 #endif /* EPERL_PERL5_H */
 /*EOF*/
diff -u -Naur eperl-2.2.14/eperl_pp.c eperl-2.2.14.fink/eperl_pp.c
--- eperl-2.2.14/eperl_pp.c	Fri Jul 10 03:51:09 1998
+++ eperl-2.2.14.fink/eperl_pp.c	Wed Nov 17 12:47:04 2004
@@ -15,7 +15,7 @@
 **
 **  ======================================================================
 **
-**  Copyright (c) 1996,1997,1998 Ralf S. Engelschall <rse@engelschall.com>
+**  Copyright (c) 1996,1997,1998,1999 Ralf S. Engelschall <rse@engelschall.com>
 **
 **  This program is free software; it may be redistributed and/or modified
 **  only under the terms of either the Artistic License or the GNU General
@@ -47,7 +47,8 @@
     va_list ap;
 
     va_start(ap, str);
-    vsprintf(ePerl_PP_ErrorString, str, ap);
+    vsnprintf(ePerl_PP_ErrorString, sizeof(ePerl_PP_ErrorString), str, ap);
+    ePerl_PP_ErrorString[sizeof(ePerl_PP_ErrorString)-1] = NUL;
     va_end(ap);
     return;
 }
@@ -113,7 +114,8 @@
             if (fp == NULL) {
                 /* we have to try in all include directories! */
                 for (i = 0; cppINC[i] != NULL; i++) {
-                    sprintf(caName, "%s/%s", cppINC[i], cpInput);
+                    snprintf(caName, sizeof(caName), "%s/%s", cppINC[i], cpInput);
+                    caName[sizeof(caName)-1] = NUL;
                     if ((fp = fopen(caName, "r")) != NULL)
                         break;
                 }
@@ -168,13 +170,13 @@
             if ((strncmp(cps, "#endif",    6) == 0) && (cp == NULL)) cp = cps;
             if ((strncmp(cps, "#c",        2) == 0) && (cp == NULL)) cp = cps;
         }
-        if (((cpT = strnstr(cps, "\n#include",  cpEND-cps)) != NULL) && ((cpT < cp) || (cp == NULL))) cp = cpT+1;
-        if (((cpT = strnstr(cps, "\n#sinclude", cpEND-cps)) != NULL) && ((cpT < cp) || (cp == NULL))) cp = cpT+1;
-        if (((cpT = strnstr(cps, "\n#if",       cpEND-cps)) != NULL) && ((cpT < cp) || (cp == NULL))) cp = cpT+1;
-        if (((cpT = strnstr(cps, "\n#elsif",    cpEND-cps)) != NULL) && ((cpT < cp) || (cp == NULL))) cp = cpT+1;
-        if (((cpT = strnstr(cps, "\n#else",     cpEND-cps)) != NULL) && ((cpT < cp) || (cp == NULL))) cp = cpT+1;
-        if (((cpT = strnstr(cps, "\n#endif",    cpEND-cps)) != NULL) && ((cpT < cp) || (cp == NULL))) cp = cpT+1;
-        if (((cpT = strnstr(cps, "\n#c",        cpEND-cps)) != NULL) && ((cpT < cp) || (cp == NULL))) cp = cpT+1;
+        if (((cpT = ePerl_strnstr(cps, "\n#include",  cpEND-cps)) != NULL) && ((cpT < cp) || (cp == NULL))) cp = cpT+1;
+        if (((cpT = ePerl_strnstr(cps, "\n#sinclude", cpEND-cps)) != NULL) && ((cpT < cp) || (cp == NULL))) cp = cpT+1;
+        if (((cpT = ePerl_strnstr(cps, "\n#if",       cpEND-cps)) != NULL) && ((cpT < cp) || (cp == NULL))) cp = cpT+1;
+        if (((cpT = ePerl_strnstr(cps, "\n#elsif",    cpEND-cps)) != NULL) && ((cpT < cp) || (cp == NULL))) cp = cpT+1;
+        if (((cpT = ePerl_strnstr(cps, "\n#else",     cpEND-cps)) != NULL) && ((cpT < cp) || (cp == NULL))) cp = cpT+1;
+        if (((cpT = ePerl_strnstr(cps, "\n#endif",    cpEND-cps)) != NULL) && ((cpT < cp) || (cp == NULL))) cp = cpT+1;
+        if (((cpT = ePerl_strnstr(cps, "\n#c",        cpEND-cps)) != NULL) && ((cpT < cp) || (cp == NULL))) cp = cpT+1;
 
         if (cp != NULL && (cp == cpBuf || (cp > cpBuf && *(cp-1) == '\n'))) {
             /* 
@@ -191,6 +193,7 @@
             }
             cpOutBuf = cp2;
             strncpy(cpOutBuf+nOut, cps, cp-cps);
+            *(cpOutBuf+nOutBuf-1) = NUL;
             nOut += i;
 
             /* 
@@ -253,7 +256,7 @@
                 }
 
                 /* copy the filename and skip to end of line */
-                for (i = 0; cps < cpEND && 
+                for (i = 0; i < sizeof(caName) && cps < cpEND && 
                             (*cps != ' ' && *cps != '\t' && 
                              *cps != '>' && *cps != '"'  &&
                              *cps != '\n'                  );  )
@@ -269,7 +272,7 @@
                     return NULL;
 
                 /* make it secure by removing all begin/end delimiters!! */
-                if ((cp2 = (char *)malloc(strlen(cp))) == NULL)
+                if ((cp2 = (char *)malloc(strlen(cp)*9/8)) == NULL)
                     return NULL;
                 l1 = strlen(ePerl_begin_delimiter);
                 l2 = strlen(ePerl_end_delimiter);
@@ -278,6 +281,11 @@
                         cp3 += l1;
                     else if (strncasecmp(cp3, ePerl_end_delimiter, l2) == 0)
                         cp3 += l2;
+                    else if (strncmp(cp3, "#include", 8) == 0) {
+                        /*  Replace all occurences of #include by #sinclude */
+                        strcpy(cp4, "#sinclude");
+                        cp4 += 9;
+                    }
                     else
                         *cp4++ = *cp3++;
                 }
@@ -301,13 +309,14 @@
                 }
 
                 /* copy the argument and create replacement string */
-                for (i = 0; cps < cpEND && *cps != '\n'; )
+                for (i = 0; i < sizeof(caArg) && cps < cpEND && *cps != '\n'; )
                     caArg[i++] = *cps++;
                 caArg[i++] = NUL;
                 if (*cps == '\n')
                     cps++;
-                sprintf(caStr, "%s if (%s) { _%s//\n", 
+                snprintf(caStr, sizeof(caStr), "%s if (%s) { _%s//\n", 
                         ePerl_begin_delimiter, caArg, ePerl_end_delimiter);
+                caStr[sizeof(caStr)-1] = NUL;
                 cp = caStr;
             }
             else if (strncmp(cp, "#elsif", 6) == 0) {
@@ -326,13 +335,14 @@
                 }
 
                 /* copy the argument and create replacement string */
-                for (i = 0; cps < cpEND && *cps != '\n'; )
+                for (i = 0; i < sizeof(caArg) && cps < cpEND && *cps != '\n'; )
                     caArg[i++] = *cps++;
                 caArg[i++] = NUL;
                 if (*cps == '\n')
                     cps++;
-                sprintf(caStr, "%s } elsif (%s) { _%s//\n", 
+                snprintf(caStr, sizeof(caStr), "%s } elsif (%s) { _%s//\n", 
                         ePerl_begin_delimiter, caArg, ePerl_end_delimiter);
+                caStr[sizeof(caStr)-1] = NUL;
                 cp = caStr;
             }
             else if (strncmp(cp, "#else", 5) == 0) {
@@ -348,8 +358,9 @@
                     cps++;
 
                 /* create replacement string */
-                sprintf(caStr, "%s } else { _%s//\n", 
+                snprintf(caStr, sizeof(caStr), "%s } else { _%s//\n", 
                         ePerl_begin_delimiter, ePerl_end_delimiter);
+                caStr[sizeof(caStr)-1] = NUL;
                 cp = caStr;
             }
             else if (strncmp(cp, "#endif", 6) == 0) {
@@ -365,8 +376,9 @@
                     cps++;
 
                 /* create replacement string */
-                sprintf(caStr, "%s } _%s//\n", 
+                snprintf(caStr, sizeof(caStr), "%s } _%s//\n", 
                         ePerl_begin_delimiter, ePerl_end_delimiter);
+                caStr[sizeof(caStr)-1] = NUL;
                 cp = caStr;
             }
             else if (strncmp(cp, "#c", 2) == 0) {
@@ -396,7 +408,8 @@
                 return NULL;
             }
             cpOutBuf = cp2;
-            strcpy(cpOutBuf+nOut, cp);
+            strncpy(cpOutBuf+nOut, cp, nOutBuf - nOut);
+            *(cpOutBuf+nOutBuf-1) = NUL;
             nOut += i;
 
             continue;
@@ -413,7 +426,8 @@
                 return NULL;
             }
             cpOutBuf = cp2;
-            strcpy(cpOutBuf+nOut, cps);
+            strncpy(cpOutBuf+nOut, cps, nOutBuf - nOut);
+            *(cpOutBuf+nOutBuf-1) = NUL;
 
             break;
         }
diff -u -Naur eperl-2.2.14/eperl_proto.h eperl-2.2.14.fink/eperl_proto.h
--- eperl-2.2.14/eperl_proto.h	1998-07-10 03:52:24.000000000 -0400
+++ eperl-2.2.14.fink/eperl_proto.h	2006-01-11 14:29:47.000000000 -0500
@@ -15,7 +15,7 @@
 **
 **  ======================================================================
 **
-**  Copyright (c) 1996,1997,1998 Ralf S. Engelschall <rse@engelschall.com>
+**  Copyright (c) 1996,1997,1998,1999 Ralf S. Engelschall <rse@engelschall.com>
 **
 **  This program is free software; it may be redistributed and/or modified
 **  only under the terms of either the Artistic License or the GNU General
@@ -43,7 +43,6 @@
 extern char *allowed_caller_uid[];
 extern void PrintError(int mode, char *scripturl, char *scriptfile, char *logfile, char *str, ...);
 extern void give_version(void);
-extern void give_version_extended(void);
 extern void give_readme(void);
 extern void give_license(void);
 extern void give_img_logo(void);
@@ -54,18 +53,10 @@
 extern void mysighandler(int rc);
 extern void myinit(void);
 extern void myexit(int rc);
+#include "eperl_getopt.h"
 extern struct option options[];
 extern int main(int argc, char **argv, char **env);
 
-/* eperl_perl5.c */
-extern void Perl5_XSInit(void);
-extern void Perl5_ForceUnbufferedStdout(void);
-extern char **Perl5_SetEnvVar(char **env, char *str);
-extern void Perl5_SetScalar(char *pname, char *vname, char *vvalue);
-extern char *Perl5_RememberedScalars[1024];
-extern void Perl5_RememberScalar(char *str);
-extern void Perl5_SetRememberedScalars(void);
-
 /* eperl_parse.c */
 extern char *ePerl_begin_delimiter;
 extern char *ePerl_end_delimiter;
@@ -79,7 +70,7 @@
 extern char *ePerl_Efwrite(char *cpBuf, int nBuf, int cNum, char *cpOut);
 extern char *ePerl_Cfwrite(char *cpBuf, int nBuf, int cNum, char *cpOut);
 extern char *strnchr(char *buf, char chr, int n);
-extern char *strnstr(char *buf, char *str, int n);
+extern char *ePerl_strnstr(char *buf, char *str, int n);
 extern char *strncasestr(char *buf, char *str, int n);
 extern char *strndup(char *buf, int n);
 extern char *ePerl_Bristled2Plain(char *cpBuf);
@@ -111,7 +102,7 @@
 extern char *abspath(char *path);
 
 /* eperl_http.c */
-extern void HTTP_PrintResponseHeaders(char *cpBuf);
+extern char *HTTP_PrintResponseHeaders(char *cpBuf);
 extern void HTTP_StripResponseHeaders(char **cpBuf, int *nBuf);
 extern int HTTP_IsHeaderLine(char *cp1, char *cp2);
 extern int HTTP_HeadersExists(char *cpBuf);
@@ -127,13 +118,6 @@
 /* eperl_config.c */
 
 /* eperl_version.c */
-extern char ePerl_Version[];
-extern char ePerl_Hello[];
-extern char ePerl_GNUVersion[];
-extern char ePerl_WhatID[];
-extern char ePerl_RCSIdentID[];
-extern char ePerl_WebID[];
-extern char ePerl_PlainID[];
 
 /* eperl_readme.c */
 extern char *ePerl_README;
@@ -143,11 +127,11 @@
 
 /* eperl_logo.c */
 extern int ePerl_LOGO_size;
-extern char ePerl_LOGO_data[];
+extern unsigned char ePerl_LOGO_data[];
 
 /* eperl_powered.c */
 extern int ePerl_POWERED_size;
-extern char ePerl_POWERED_data[];
+extern unsigned char ePerl_POWERED_data[];
 /*_END_PROTO_*/
 
 #endif /* EPERL_PROTO_H */
diff -u -Naur eperl-2.2.14/eperl_proto.h.orig eperl-2.2.14.fink/eperl_proto.h.orig
--- eperl-2.2.14/eperl_proto.h.orig	Wed Dec 31 19:00:00 1969
+++ eperl-2.2.14.fink/eperl_proto.h.orig	Wed Nov 17 12:47:04 2004
@@ -0,0 +1,154 @@
+/*
+**        ____           _ 
+**    ___|  _ \ ___ _ __| |
+**   / _ \ |_) / _ \ '__| |
+**  |  __/  __/  __/ |  | |
+**   \___|_|   \___|_|  |_|
+** 
+**  ePerl -- Embedded Perl 5 Language
+**
+**  ePerl interprets an ASCII file bristled with Perl 5 program statements
+**  by evaluating the Perl 5 code while passing through the plain ASCII
+**  data. It can operate both as a standard Unix filter for general file
+**  generation tasks and as a powerful Webserver scripting language for
+**  dynamic HTML page programming. 
+**
+**  ======================================================================
+**
+**  Copyright (c) 1996,1997,1998 Ralf S. Engelschall <rse@engelschall.com>
+**
+**  This program is free software; it may be redistributed and/or modified
+**  only under the terms of either the Artistic License or the GNU General
+**  Public License, which may be found in the ePerl source distribution.
+**  Look at the files ARTISTIC and COPYING or run ``eperl -l'' to receive
+**  a built-in copy of both license files.
+**
+**  This program is distributed in the hope that it will be useful, but
+**  WITHOUT ANY WARRANTY; without even the implied warranty of
+**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See either the
+**  Artistic License or the GNU General Public License for more details.
+**
+**  ======================================================================
+**
+**  eperl_proto.h -- ePerl ANSI C prototypes
+*/
+#ifndef EPERL_PROTO_H
+#define EPERL_PROTO_H 1
+
+/*_BEGIN_PROTO_*/
+
+/* eperl_main.c */
+extern int mode;
+extern char *allowed_file_ext[];
+extern char *allowed_caller_uid[];
+extern void PrintError(int mode, char *scripturl, char *scriptfile, char *logfile, char *str, ...);
+extern void give_version(void);
+extern void give_version_extended(void);
+extern void give_readme(void);
+extern void give_license(void);
+extern void give_img_logo(void);
+extern void give_img_powered(void);
+extern void give_usage(char *name);
+extern char *RememberedINC[1024];
+extern void RememberINC(char *str);
+extern void mysighandler(int rc);
+extern void myinit(void);
+extern void myexit(int rc);
+extern struct option options[];
+extern int main(int argc, char **argv, char **env);
+
+/* eperl_perl5.c */
+extern void Perl5_XSInit(void);
+extern void Perl5_ForceUnbufferedStdout(void);
+extern char **Perl5_SetEnvVar(char **env, char *str);
+extern void Perl5_SetScalar(char *pname, char *vname, char *vvalue);
+extern char *Perl5_RememberedScalars[1024];
+extern void Perl5_RememberScalar(char *str);
+extern void Perl5_SetRememberedScalars(void);
+
+/* eperl_parse.c */
+extern char *ePerl_begin_delimiter;
+extern char *ePerl_end_delimiter;
+extern int ePerl_case_sensitive_delimiters;
+extern int ePerl_convert_entities;
+extern int ePerl_line_continuation;
+extern void ePerl_SetError(char *str, ...);
+extern char *ePerl_GetError(void);
+extern char *ePerl_fprintf(char *cpOut, char *str, ...);
+extern char *ePerl_fwrite(char *cpBuf, int nBuf, int cNum, char *cpOut);
+extern char *ePerl_Efwrite(char *cpBuf, int nBuf, int cNum, char *cpOut);
+extern char *ePerl_Cfwrite(char *cpBuf, int nBuf, int cNum, char *cpOut);
+extern char *strnchr(char *buf, char chr, int n);
+extern char *ePerl_strnstr(char *buf, char *str, int n);
+extern char *strncasestr(char *buf, char *str, int n);
+extern char *strndup(char *buf, int n);
+extern char *ePerl_Bristled2Plain(char *cpBuf);
+
+/* eperl_pp.c */
+extern void ePerl_PP_SetError(char *str, ...);
+extern char *ePerl_PP_GetError(void);
+extern char *ePerl_PP_Process(char *cpInput, char **cppINC, int mode);
+extern char *ePerl_PP(char *cpBuf, char **cppINC);
+
+/* eperl_sys.c */
+extern char **mysetenv(char **env, char *var, char *str, ...);
+extern void IO_redirect_stdin(FILE *fp);
+extern void IO_redirect_stdout(FILE *fp);
+extern void IO_redirect_stderr(FILE *fp);
+extern int IO_is_stdin_redirected(void);
+extern int IO_is_stdout_redirected(void);
+extern int IO_is_stderr_redirected(void);
+extern void IO_restore_stdin(void);
+extern void IO_restore_stdout(void);
+extern void IO_restore_stderr(void);
+extern char *mytmpfile(char *id);
+extern void remove_mytmpfiles(void);
+extern char *isotime(time_t *t);
+extern char *ePerl_ReadSourceFile(char *filename, char **cpBufC, int *nBufC);
+extern char *ePerl_ReadErrorFile(char *filename, char *scriptfile, char *scripturl);
+extern char *filename(char *path);
+extern char *dirname(char *path);
+extern char *abspath(char *path);
+
+/* eperl_http.c */
+extern void HTTP_PrintResponseHeaders(char *cpBuf);
+extern void HTTP_StripResponseHeaders(char **cpBuf, int *nBuf);
+extern int HTTP_IsHeaderLine(char *cp1, char *cp2);
+extern int HTTP_HeadersExists(char *cpBuf);
+extern int HTTP_HeaderLineExists(char *cpBuf, char *name);
+extern char *WebTime(void);
+extern FILE *HTTP_openURLasFP(char *url);
+
+/* eperl_debug.c */
+extern int fDebug;
+extern char *cpDebugFile;
+extern void Debug(char *str, ...);
+
+/* eperl_config.c */
+
+/* eperl_version.c */
+extern char ePerl_Version[];
+extern char ePerl_Hello[];
+extern char ePerl_GNUVersion[];
+extern char ePerl_WhatID[];
+extern char ePerl_RCSIdentID[];
+extern char ePerl_WebID[];
+extern char ePerl_PlainID[];
+
+/* eperl_readme.c */
+extern char *ePerl_README;
+
+/* eperl_license.c */
+extern char *ePerl_LICENSE;
+
+/* eperl_logo.c */
+extern int ePerl_LOGO_size;
+extern char ePerl_LOGO_data[];
+
+/* eperl_powered.c */
+extern int ePerl_POWERED_size;
+extern char ePerl_POWERED_data[];
+/*_END_PROTO_*/
+
+#endif /* EPERL_PROTO_H */
+/*EOF*/
diff -u -Naur eperl-2.2.14/eperl_readme.c eperl-2.2.14.fink/eperl_readme.c
--- eperl-2.2.14/eperl_readme.c	Sun Aug  2 09:22:29 1998
+++ eperl-2.2.14.fink/eperl_readme.c	Wed Nov 17 12:45:58 2004
@@ -18,9 +18,9 @@
 "  scripting language for dynamic HTML page programming. \n"\
 "\n"\
 "  The documentation and latest release can be found on\n"\
-"  http://www.engelschall.com/sw/eperl/\n"\
+"  http://www.ossp.org/pkg/tool/eperl/\n"\
 "\n"\
-"  Copyright (c) 1996,1997,1998 Ralf S. Engelschall <rse@engelschall.com>\n"\
+"  Copyright (c) 1996,1997,1998,1999 Ralf S. Engelschall <rse@engelschall.com>\n"\
 "\n"\
 "  This program is free software; it may be redistributed and/or modified only\n"\
 "  under the terms of either the Artistic License or the GNU General Public\n"\
diff -u -Naur eperl-2.2.14/eperl_security.h eperl-2.2.14.fink/eperl_security.h
--- eperl-2.2.14/eperl_security.h	Fri Jul 10 03:52:30 1998
+++ eperl-2.2.14.fink/eperl_security.h	Wed Nov 17 12:45:58 2004
@@ -15,7 +15,7 @@
 **
 **  ======================================================================
 **
-**  Copyright (c) 1996,1997,1998 Ralf S. Engelschall <rse@engelschall.com>
+**  Copyright (c) 1996,1997,1998,1999 Ralf S. Engelschall <rse@engelschall.com>
 **
 **  This program is free software; it may be redistributed and/or modified
 **  only under the terms of either the Artistic License or the GNU General
@@ -58,7 +58,7 @@
 #define SETUID_NEEDS_VALID_OWNER_UID     TRUE
 #define SETUID_NEEDS_VALID_OWNER_GID     TRUE
 #define SETUID_NEEDS_BELOW_OWNER_HOME    TRUE
-#define LIST_OF_ALLOWED_CALLER_UID       { "nobody", "root", NULL }
+#define LIST_OF_ALLOWED_CALLER_UID       { "nobody", "root", "www-data", NULL }
 
 /* 
  * Action when a SetUID security check failed.
